import React, { useState, useCallback, useEffect } from 'react';
import ReactDOM from 'react-dom';
import { arc, pie, range } from 'd3';

const width = 960;
const height = 500;
const centerX = width / 2;
const centerY = height / 2;

const pieArc = arc()
  .innerRadius(0)
  .outerRadius(width);

const data = range(3000).map((d, i) => i % 2 ? 'black' : 'white');

const App = () => {

  const colorPie = pie().value(1);

  return (
    <svg width={width} height={height}>
      <g transform={`translate(0,${centerY})`}>
        {colorPie(data).map(d => (
          <path fill={d.data} d={pieArc(d)} />
        ))}
      </g>
    </svg>
  );
};
const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);

// To compute the arcs manually (without d3.pie):
// data.map((d, i) => (
//   <path
//     fill={d['RGB hex value']}
//     d={pieArc({
//       startAngle: (i / data.length) * 2 * Math.PI,
//       endAngle: ((i + 1) / data.length) * 2 * Math.PI
//     })}
//   />
// ))
